package betterwithmods.client.container.bulk;

import betterwithmods.common.blocks.mechanical.tile.TileEntityFilteredHopper;
import betterwithmods.common.registry.HopperFilters;
import betterwithmods.util.InvUtils;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IContainerListener;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.SlotItemHandler;

public class ContainerFilteredHopper extends Container {
    private final TileEntityFilteredHopper tile;
    private byte lastMechPower;

    public ContainerFilteredHopper(EntityPlayer player, TileEntityFilteredHopper tile) {
        this.tile = tile;
        this.lastMechPower = 0;

        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(tile.inventory, j + i * 9, 8 + j * 18, 60 + i * 18));
            }
        }

        func_75146_a(new SlotItemHandler(tile.filter, 0, 80, 37));

        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 9; j++) {
                func_75146_a(new SlotItemHandler(player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null), j + i * 9 + 9, 8 + j * 18, 111 + i * 18));
            }
        }

        for (int i = 0; i < 9; i++) {
            func_75146_a(new SlotItemHandler(player.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null), i, 8 + i * 18, 169));
        }
    }
    @Override
    public ItemStack func_82846_b(EntityPlayer player, int index) {
        ItemStack clickedStack = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d()) {
            ItemStack processedStack = slot.func_75211_c();
            clickedStack = processedStack.func_77946_l();

            if (index < 19) {
                if (!func_75135_a(processedStack, 19, this.field_75151_b.size(), true))
                    return ItemStack.field_190927_a;
            } else if (isItemFilter(processedStack)) {
                if (!func_75135_a(processedStack, 18, 19, false))
                    return ItemStack.field_190927_a;
            } else if (!func_75135_a(processedStack, 0, 18, false)) {
                return ItemStack.field_190927_a;
            }

            if (processedStack.func_190916_E() == 0)
                slot.func_75215_d(ItemStack.field_190927_a);
            else
                slot.func_75218_e();
        }
        return clickedStack;
    }

    public boolean isItemFilter(ItemStack stack) {
        return HopperFilters.filterTypes.keySet().stream().anyMatch( s -> InvUtils.matches(s, stack));
    }

    @Override
    public void func_75132_a(IContainerListener listener) {
        super.func_75132_a(listener);
        listener.func_71112_a(this, 0, this.tile.power);
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();

        for (IContainerListener craft : this.field_75149_d) {
            if (this.lastMechPower != this.tile.power)
                craft.func_71112_a(this, 0, this.tile.power);
        }
        this.lastMechPower = this.tile.power;
    }

    @Override
    public void func_75137_b(int index, int value) {
        if (index == 0)
            this.tile.power = (byte) value;
    }

    @Override
    public boolean func_75145_c(EntityPlayer playerIn) {
        return tile.isUseableByPlayer(playerIn);
    }

}
